#include <iostream>
using namespace std;

int main()
{
    int n;
    cin>>n;
    int a[n];
    int b[n];
    int atren=0;
    int btren=0;
    int amax;
    cin>>amax;
    int amin=amax;
    int bmax;
    cin>>bmax;
    int bmin=bmax;
    int bminvred=0;
    int bmaxvred=0;
    int aminvred=0;
    int amaxvred=0;
    cout<<0<<endl;
    for(int i=1;i<n;i++){
        int asad;
        int bsad;
        cin>>asad>>bsad;
        if(asad<amin){
            aminvred+=i*(asad-amin);
            amin=asad;
        }
        else if(asad>amax){
            amaxvred+=i*(asad-amax);
            amax=asad;
        }
        else{
            amaxvred+=amax-asad;
            aminvred+=asad-amin;
        }
        atren=max(amaxvred,aminvred);
        if(bsad<bmin){
            bminvred+=i*(bsad-bmin);
            bmin=bsad;
        }
        else if(bsad>bmax){
            bmaxvred+=i*(bsad-bmax);
            bmax=bsad;
        }
        else{
            bmaxvred+=bmax-bsad;
            bminvred+=bsad-bmin;
        }
        btren=max(bmaxvred,bminvred);
        cout<<atren*btren<<endl;
    }
}